//+------------------------------------------------------------------+
//|                                               _.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
extern double       lots=0.1;
extern double       asr = 0.022;
extern double       asrst = 0.12;
extern int          sla = 30;
extern int          tpa = 71;

//---- input parameters
extern int       FastEMA=5;
extern int       SliowEMA=34;
extern int       SignalEMA=5;
extern bool      sound=false;
//----
static int prevtime = 0 ;
static int prevbars = 0 ;
double mode1,mode2;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
/*
Alert("!");
Sleep(1000); 
Alert("    !");
int total = OrdersTotal();
   if (total>0)
      {
      for (int i=0;i<total;i++)
          {
          OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
          int ticket = OrderTicket( ) ;
          if (OrderSymbol() == Symbol())
             {
             OrderClose(ticket,OrderLots(),Ask,3,Red);
             OrderClose(ticket,OrderLots(),Bid,3,Blue);
             }
          }
      }  
Sleep(3000);      
Alert("!!!");  */    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
// ,    
   if (Time[0] == prevtime) return(0);
      prevtime = Time[0];
double ma31 = iMA(NULL,0,54,0,MODE_LWMA,PRICE_MEDIAN,1);
//double ma32 = iMA(NULL,0,3,0,MODE_EMA,PRICE_MEDIAN,2);
//double ma33 = iMA(NULL,0,3,0,MODE_EMA,PRICE_MEDIAN,3);      
//--------------------------------------------------------------------+
bool mode;      
double ppo5 = iCustom(NULL,0,"PPO",FastEMA,SliowEMA,SignalEMA,sound,1,1);
double sign5 = iCustom(NULL,0,"PPO",FastEMA,SliowEMA,SignalEMA,sound,2,2);
if (ppo5>sign5){mode = true;}
if (ppo5<sign5){mode = false;}
//--------------------------------------------------------------------+
double sar = iSAR(NULL,0,asr,asrst,0);  
double sl= (sla)*Point;
double tp= (tpa)*Point;
double stop;
int total = OrdersTotal();
int tip = OrderType();    
//---------------------------------------------------------------------+
 // if (market<=1)&&(total<0)      

 OrderSelect(0, SELECT_BY_POS, MODE_TRADES);int ticket =OrderTicket(); 
  
  if ((mode == true)&&(sar>Bid)&&(OrdersTotal()==0)){RefreshRates();ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,3,Ask+sl,Bid-tp,0,0,Blue);} 
  if ((mode == false)&&(sar<Ask)&&(OrdersTotal()==0)){RefreshRates();ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,3,Bid-sl,Ask+tp,0,0,Blue);} 
  if ((total>0))
     {
     for (int n=0;n<total;n++)
     OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
     ticket = OrderTicket( ) ;
              
     if ((OrderSymbol() == Symbol())&&(OrderType()==OP_BUY)/*&&(OrderProfit()>0)*/)
        {
         stop=MathAbs(OrderStopLoss()-Bid)/Point;
          stop = iSAR(NULL,0,asr,asrst,0);        
           OrderModify(ticket,OrderOpenPrice(),stop,0,0,Green);
            }//else {OrderClose(ticket,OrderLots(),Ask,3,Red);}  
     if ((OrderSymbol() == Symbol())&&(OrderType()==OP_SELL)/*&&(OrderProfit()>0)*/)
          {
           stop=MathAbs(OrderStopLoss()-Ask)/Point;
            stop = iSAR(NULL,0,asr,asrst,0); //(stop*0.99)*Point;
             OrderModify(ticket,OrderOpenPrice(),stop,0,0,Green);
              }//else {OrderClose(ticket,OrderLots(),Bid,3,Red);}
                         
      }
   return(0);
  }
//+------------------------------------------------------------------+